//
// Generated by JTB 1.2.2
//

package xtc.lang.javacc.visitor;
import xtc.lang.javacc.syntaxtree.*;
import java.util.*;

/**
 * All void visitors must implement this interface.
 */
public interface Visitor {
   //
   // void Auto class visitors
   //
   public void visit(NodeList n);
   public void visit(NodeListOptional n);
   public void visit(NodeOptional n);
   public void visit(NodeSequence n);
   public void visit(NodeToken n);

   //
   // User-generated visitor methods below
   //

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> [ PackageDeclaration() ]
    * f1 -> ( ImportDeclaration() )*
    * f2 -> ( TypeDeclaration() )*
    * f3 -> &lt;EOF&gt;
    * </pre>
    */
   public void visit(CompilationUnit n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> "package"
    * f1 -> Name()
    * f2 -> ";"
    * </pre>
    */
   public void visit(PackageDeclaration n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> "import"
    * f1 -> Name()
    * f2 -> [ "." "*" ]
    * f3 -> ";"
    * </pre>
    */
   public void visit(ImportDeclaration n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> ClassDeclaration()
    *       | InterfaceDeclaration()
    *       | ";"
    * </pre>
    */
   public void visit(TypeDeclaration n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> ( "abstract" | "final" | "public" | "strictfp" )*
    * f1 -> UnmodifiedClassDeclaration()
    * </pre>
    */
   public void visit(ClassDeclaration n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> "class"
    * f1 -> &lt;IDENTIFIER&gt;
    * f2 -> [ "extends" Name() ]
    * f3 -> [ "implements" NameList() ]
    * f4 -> ClassBody()
    * </pre>
    */
   public void visit(UnmodifiedClassDeclaration n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> "{"
    * f1 -> ( ClassBodyDeclaration() )*
    * f2 -> "}"
    * </pre>
    */
   public void visit(ClassBody n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> ( "static" | "abstract" | "final" | "public" | "protected" | "private" | "strictfp" )*
    * f1 -> UnmodifiedClassDeclaration()
    * </pre>
    */
   public void visit(NestedClassDeclaration n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> Initializer()
    *       | NestedClassDeclaration()
    *       | NestedInterfaceDeclaration()
    *       | ConstructorDeclaration()
    *       | MethodDeclaration()
    *       | FieldDeclaration()
    *       | ";"
    * </pre>
    */
   public void visit(ClassBodyDeclaration n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> ( "public" | "protected" | "private" | "static" | "abstract" | "final" | "native" | "synchronized" | "strictfp" )*
    * f1 -> ResultType()
    * f2 -> &lt;IDENTIFIER&gt;
    * f3 -> "("
    * </pre>
    */
   public void visit(MethodDeclarationLookahead n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> ( "abstract" | "public" | "strictfp" )*
    * f1 -> UnmodifiedInterfaceDeclaration()
    * </pre>
    */
   public void visit(InterfaceDeclaration n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> ( "static" | "abstract" | "final" | "public" | "protected" | "private" | "strictfp" )*
    * f1 -> UnmodifiedInterfaceDeclaration()
    * </pre>
    */
   public void visit(NestedInterfaceDeclaration n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> "interface"
    * f1 -> &lt;IDENTIFIER&gt;
    * f2 -> [ "extends" NameList() ]
    * f3 -> "{"
    * f4 -> ( InterfaceMemberDeclaration() )*
    * f5 -> "}"
    * </pre>
    */
   public void visit(UnmodifiedInterfaceDeclaration n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> NestedClassDeclaration()
    *       | NestedInterfaceDeclaration()
    *       | MethodDeclaration()
    *       | FieldDeclaration()
    *       | ";"
    * </pre>
    */
   public void visit(InterfaceMemberDeclaration n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> ( "public" | "protected" | "private" | "static" | "final" | "transient" | "volatile" )*
    * f1 -> Type()
    * f2 -> VariableDeclarator()
    * f3 -> ( "," VariableDeclarator() )*
    * f4 -> ";"
    * </pre>
    */
   public void visit(FieldDeclaration n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> VariableDeclaratorId()
    * f1 -> [ "=" VariableInitializer() ]
    * </pre>
    */
   public void visit(VariableDeclarator n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> &lt;IDENTIFIER&gt;
    * f1 -> ( "[" "]" )*
    * </pre>
    */
   public void visit(VariableDeclaratorId n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> ArrayInitializer()
    *       | Expression()
    * </pre>
    */
   public void visit(VariableInitializer n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> "{"
    * f1 -> [ VariableInitializer() ( "," VariableInitializer() )* ]
    * f2 -> [ "," ]
    * f3 -> "}"
    * </pre>
    */
   public void visit(ArrayInitializer n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> ( "public" | "protected" | "private" | "static" | "abstract" | "final" | "native" | "synchronized" | "strictfp" )*
    * f1 -> ResultType()
    * f2 -> MethodDeclarator()
    * f3 -> [ "throws" NameList() ]
    * f4 -> ( Block() | ";" )
    * </pre>
    */
   public void visit(MethodDeclaration n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> &lt;IDENTIFIER&gt;
    * f1 -> FormalParameters()
    * f2 -> ( "[" "]" )*
    * </pre>
    */
   public void visit(MethodDeclarator n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> "("
    * f1 -> [ FormalParameter() ( "," FormalParameter() )* ]
    * f2 -> ")"
    * </pre>
    */
   public void visit(FormalParameters n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> [ "final" ]
    * f1 -> Type()
    * f2 -> VariableDeclaratorId()
    * </pre>
    */
   public void visit(FormalParameter n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> [ "public" | "protected" | "private" ]
    * f1 -> &lt;IDENTIFIER&gt;
    * f2 -> FormalParameters()
    * f3 -> [ "throws" NameList() ]
    * f4 -> "{"
    * f5 -> [ ExplicitConstructorInvocation() ]
    * f6 -> ( BlockStatement() )*
    * f7 -> "}"
    * </pre>
    */
   public void visit(ConstructorDeclaration n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> "this" Arguments() ";"
    *       | [ PrimaryExpression() "." ] "super" Arguments() ";"
    * </pre>
    */
   public void visit(ExplicitConstructorInvocation n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> [ "static" ]
    * f1 -> Block()
    * </pre>
    */
   public void visit(Initializer n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> ( PrimitiveType() | Name() )
    * f1 -> ( "[" "]" )*
    * </pre>
    */
   public void visit(Type n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> "boolean"
    *       | "char"
    *       | "byte"
    *       | "short"
    *       | "int"
    *       | "long"
    *       | "float"
    *       | "double"
    * </pre>
    */
   public void visit(PrimitiveType n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> "void"
    *       | Type()
    * </pre>
    */
   public void visit(ResultType n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> &lt;IDENTIFIER&gt;
    * f1 -> ( "." &lt;IDENTIFIER&gt; )*
    * </pre>
    */
   public void visit(Name n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> Name()
    * f1 -> ( "," Name() )*
    * </pre>
    */
   public void visit(NameList n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> ConditionalExpression()
    * f1 -> [ AssignmentOperator() Expression() ]
    * </pre>
    */
   public void visit(Expression n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> "="
    *       | "*="
    *       | "/="
    *       | "%="
    *       | "+="
    *       | "-="
    *       | "&lt;&lt;="
    *       | "&gt;&gt;="
    *       | "&gt;&gt;&gt;="
    *       | "&="
    *       | "^="
    *       | "|="
    * </pre>
    */
   public void visit(AssignmentOperator n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> ConditionalOrExpression()
    * f1 -> [ "?" Expression() ":" ConditionalExpression() ]
    * </pre>
    */
   public void visit(ConditionalExpression n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> ConditionalAndExpression()
    * f1 -> ( "||" ConditionalAndExpression() )*
    * </pre>
    */
   public void visit(ConditionalOrExpression n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> InclusiveOrExpression()
    * f1 -> ( "&&" InclusiveOrExpression() )*
    * </pre>
    */
   public void visit(ConditionalAndExpression n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> ExclusiveOrExpression()
    * f1 -> ( "|" ExclusiveOrExpression() )*
    * </pre>
    */
   public void visit(InclusiveOrExpression n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> AndExpression()
    * f1 -> ( "^" AndExpression() )*
    * </pre>
    */
   public void visit(ExclusiveOrExpression n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> EqualityExpression()
    * f1 -> ( "&" EqualityExpression() )*
    * </pre>
    */
   public void visit(AndExpression n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> InstanceOfExpression()
    * f1 -> ( ( "==" | "!=" ) InstanceOfExpression() )*
    * </pre>
    */
   public void visit(EqualityExpression n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> RelationalExpression()
    * f1 -> [ "instanceof" Type() ]
    * </pre>
    */
   public void visit(InstanceOfExpression n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> ShiftExpression()
    * f1 -> ( ( "&lt;" | "&gt;" | "&lt;=" | "&gt;=" ) ShiftExpression() )*
    * </pre>
    */
   public void visit(RelationalExpression n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> AdditiveExpression()
    * f1 -> ( ( "&lt;&lt;" | "&gt;&gt;" | "&gt;&gt;&gt;" ) AdditiveExpression() )*
    * </pre>
    */
   public void visit(ShiftExpression n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> MultiplicativeExpression()
    * f1 -> ( ( "+" | "-" ) MultiplicativeExpression() )*
    * </pre>
    */
   public void visit(AdditiveExpression n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> UnaryExpression()
    * f1 -> ( ( "*" | "/" | "%" ) UnaryExpression() )*
    * </pre>
    */
   public void visit(MultiplicativeExpression n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> ( "+" | "-" ) UnaryExpression()
    *       | PreIncrementExpression()
    *       | PreDecrementExpression()
    *       | UnaryExpressionNotPlusMinus()
    * </pre>
    */
   public void visit(UnaryExpression n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> "++"
    * f1 -> PrimaryExpression()
    * </pre>
    */
   public void visit(PreIncrementExpression n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> "--"
    * f1 -> PrimaryExpression()
    * </pre>
    */
   public void visit(PreDecrementExpression n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> ( "~" | "!" ) UnaryExpression()
    *       | CastExpression()
    *       | PostfixExpression()
    * </pre>
    */
   public void visit(UnaryExpressionNotPlusMinus n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> "(" PrimitiveType()
    *       | "(" Name() "[" "]"
    *       | "(" Name() ")" ( "~" | "!" | "(" | &lt;IDENTIFIER&gt; | "this" | "super" | "new" | Literal() )
    * </pre>
    */
   public void visit(CastLookahead n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> PrimaryExpression()
    * f1 -> [ "++" | "--" ]
    * </pre>
    */
   public void visit(PostfixExpression n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> "(" Type() ")" UnaryExpression()
    *       | "(" Type() ")" UnaryExpressionNotPlusMinus()
    * </pre>
    */
   public void visit(CastExpression n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> PrimaryPrefix()
    * f1 -> ( PrimarySuffix() )*
    * </pre>
    */
   public void visit(PrimaryExpression n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> Literal()
    *       | "this"
    *       | "super" "." &lt;IDENTIFIER&gt;
    *       | "(" Expression() ")"
    *       | AllocationExpression()
    *       | ResultType() "." "class"
    *       | Name()
    * </pre>
    */
   public void visit(PrimaryPrefix n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> "." "this"
    *       | "." "super"
    *       | "." AllocationExpression()
    *       | "[" Expression() "]"
    *       | "." &lt;IDENTIFIER&gt;
    *       | Arguments()
    * </pre>
    */
   public void visit(PrimarySuffix n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> &lt;INTEGER_LITERAL&gt;
    *       | &lt;FLOATING_POINT_LITERAL&gt;
    *       | &lt;CHARACTER_LITERAL&gt;
    *       | &lt;STRING_LITERAL&gt;
    *       | BooleanLiteral()
    *       | NullLiteral()
    * </pre>
    */
   public void visit(Literal n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> "true"
    *       | "false"
    * </pre>
    */
   public void visit(BooleanLiteral n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> "null"
    * </pre>
    */
   public void visit(NullLiteral n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> "("
    * f1 -> [ ArgumentList() ]
    * f2 -> ")"
    * </pre>
    */
   public void visit(Arguments n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> Expression()
    * f1 -> ( "," Expression() )*
    * </pre>
    */
   public void visit(ArgumentList n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> "new" PrimitiveType() ArrayDimsAndInits()
    *       | "new" Name() ( ArrayDimsAndInits() | Arguments() [ ClassBody() ] )
    * </pre>
    */
   public void visit(AllocationExpression n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> ( "[" Expression() "]" )+ ( "[" "]" )*
    *       | ( "[" "]" )+ ArrayInitializer()
    * </pre>
    */
   public void visit(ArrayDimsAndInits n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> LabeledStatement()
    *       | Block()
    *       | EmptyStatement()
    *       | StatementExpression() ";"
    *       | SwitchStatement()
    *       | IfStatement()
    *       | WhileStatement()
    *       | DoStatement()
    *       | ForStatement()
    *       | BreakStatement()
    *       | ContinueStatement()
    *       | ReturnStatement()
    *       | ThrowStatement()
    *       | SynchronizedStatement()
    *       | TryStatement()
    *       | AssertStatement()
    * </pre>
    */
   public void visit(Statement n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> &lt;IDENTIFIER&gt;
    * f1 -> ":"
    * f2 -> Statement()
    * </pre>
    */
   public void visit(LabeledStatement n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> "{"
    * f1 -> ( BlockStatement() )*
    * f2 -> "}"
    * </pre>
    */
   public void visit(Block n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> LocalVariableDeclaration() ";"
    *       | Statement()
    *       | UnmodifiedClassDeclaration()
    *       | UnmodifiedInterfaceDeclaration()
    * </pre>
    */
   public void visit(BlockStatement n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> [ "final" ]
    * f1 -> Type()
    * f2 -> VariableDeclarator()
    * f3 -> ( "," VariableDeclarator() )*
    * </pre>
    */
   public void visit(LocalVariableDeclaration n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> ";"
    * </pre>
    */
   public void visit(EmptyStatement n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> PreIncrementExpression()
    *       | PreDecrementExpression()
    *       | PrimaryExpression() [ "++" | "--" | AssignmentOperator() Expression() ]
    * </pre>
    */
   public void visit(StatementExpression n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> "switch"
    * f1 -> "("
    * f2 -> Expression()
    * f3 -> ")"
    * f4 -> "{"
    * f5 -> ( SwitchLabel() ( BlockStatement() )* )*
    * f6 -> "}"
    * </pre>
    */
   public void visit(SwitchStatement n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> "case" Expression() ":"
    *       | "default" ":"
    * </pre>
    */
   public void visit(SwitchLabel n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> "if"
    * f1 -> "("
    * f2 -> Expression()
    * f3 -> ")"
    * f4 -> Statement()
    * f5 -> [ "else" Statement() ]
    * </pre>
    */
   public void visit(IfStatement n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> "while"
    * f1 -> "("
    * f2 -> Expression()
    * f3 -> ")"
    * f4 -> Statement()
    * </pre>
    */
   public void visit(WhileStatement n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> "do"
    * f1 -> Statement()
    * f2 -> "while"
    * f3 -> "("
    * f4 -> Expression()
    * f5 -> ")"
    * f6 -> ";"
    * </pre>
    */
   public void visit(DoStatement n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> "for"
    * f1 -> "("
    * f2 -> [ ForInit() ]
    * f3 -> ";"
    * f4 -> [ Expression() ]
    * f5 -> ";"
    * f6 -> [ ForUpdate() ]
    * f7 -> ")"
    * f8 -> Statement()
    * </pre>
    */
   public void visit(ForStatement n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> LocalVariableDeclaration()
    *       | StatementExpressionList()
    * </pre>
    */
   public void visit(ForInit n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> StatementExpression()
    * f1 -> ( "," StatementExpression() )*
    * </pre>
    */
   public void visit(StatementExpressionList n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> StatementExpressionList()
    * </pre>
    */
   public void visit(ForUpdate n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> "break"
    * f1 -> [ &lt;IDENTIFIER&gt; ]
    * f2 -> ";"
    * </pre>
    */
   public void visit(BreakStatement n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> "continue"
    * f1 -> [ &lt;IDENTIFIER&gt; ]
    * f2 -> ";"
    * </pre>
    */
   public void visit(ContinueStatement n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> "return"
    * f1 -> [ Expression() ]
    * f2 -> ";"
    * </pre>
    */
   public void visit(ReturnStatement n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> "throw"
    * f1 -> Expression()
    * f2 -> ";"
    * </pre>
    */
   public void visit(ThrowStatement n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> "synchronized"
    * f1 -> "("
    * f2 -> Expression()
    * f3 -> ")"
    * f4 -> Block()
    * </pre>
    */
   public void visit(SynchronizedStatement n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> "try"
    * f1 -> Block()
    * f2 -> ( "catch" "(" FormalParameter() ")" Block() )*
    * f3 -> [ "finally" Block() ]
    * </pre>
    */
   public void visit(TryStatement n);

   /**
    * Visit the specified node.
    * <pre>
    * f0 -> "assert"
    * f1 -> Expression()
    * f2 -> [ ":" Expression() ]
    * f3 -> ";"
    * </pre>
    */
   public void visit(AssertStatement n);

}

